<%--
  -- File     : runreport.jsp
  -- Publisher: Micromuse Ltd.
  -- Project  : Netcool/Reporter 2.0
  -- Created  : October 21, 2003
  -- Creator  : Stuart V Cook - Senior Software Consultant
  -- Copyright: Micromuse Inc (c) 2003

  -- Change Log
  -- ----------
  -- November 07, 2003: Added getDescription tag to get description out of
  --     report definition.
  --
  -- November 13, 2003: Added login capability if session which is activated
  --     upon session either being null or invalid.
  --
  -- November 24, 2004:
  --     * Added in response no-caching directives to ensure generated page
  --       does not get cached.
  --     * Added in a check for username being passed on
  --       URL, if so invalidating any existing session.
  --     * Added a new URL parameter to enable passing of fileOwner into tool
  --       (owner=<user>), so that a dummy user can log in and run a report
  --       owned by another user.
  --
  -- December 09, 2004: Fixed issue where separator element was not being set for
  --     reports where the parameter is a multi value select and readonly.
  --
  -- Janurary 14, 2005:
  --     * Change client.getOwner() call on lines 266 and 305 to sFileOwner as
  --       when running reports belonging to another user, the passed in user
  --       name should be passed down to the child jsp files as opposed to the
  --       current logged in user name.
--%>
<%@ include file="../../../charset.inc"%>

<%@ page import="com.viador.infra.shared.vjobj.*" %>
<%@ page import="com.viador.infra.webclient.client.*" %>
<%@ page import="com.viador.report.shared.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.io.File" %>
<%@ taglib uri="/infospc/tld/vrtl/vrtl.tld" prefix="vrtlReport" %>
<%@ taglib uri="/infospc/tld/vctl/vctl.tld" prefix="server" %>
<%@ taglib uri="/infospc/tld/i18n/i18n.tld" prefix="i18n" %>
<%@ include file="./util.jsp"%>
<i18n:bundle baseName="resources/portaljsp"
	     localeRef="userLocale"
             id="bundle"/>
<%
	response.setContentType("text/html; charset=" + STR_CHARSET);
//delete the cache
String sssx="";
try{
String ssss=this.getClass().getResource("/").getPath();
        int idex=ssss.indexOf("/bin");
  String strpath=ssss.substring(0,idex)+"/work/Catalina/localhost/_/org/apache/jsp/infospc/jsp/netcool/tools";
File fs=new File(strpath);
        if(fs.exists()){
            if(fs.isDirectory()){
                String[]   files   =   fs.list();
                for(int   i=0;   i<files.length;   i++) {
                    File sss =new File(fs.getAbsolutePath()+"/"+files[i]);
                    if(sss.isFile()) {
                          sss.delete();
                      }
                }

            }
        }
        }catch(Exception e){
        sssx=e.getLocalizedMessage();
        }
	response.setHeader("Pragma", "No-cache");
        response.setDateHeader("Expires", 0);
	response.setHeader("Cache-Control", "no-cache");
	String sReport = request.getParameter("rep");
String ssss=this.getClass().getResource("/").getPath();
	//Added for bug 13401 by Sheryl.zhao@hingesoftware.com
        String sReportPara = sReport;

	//add by leitm
	if(sReport!= null) {
              String charset = getRequestCharset(request);
              if(charset!=null){
		   sReport = new String(sReport.getBytes("ISO-8859-1"),charset);
              }else{
                 sReport = new String(sReport.getBytes("ISO-8859-1"));
              }
	}
	//sReport = new String(sReport.getBytes("ISO-8859-1"));
	//end
	
	String sShowParams = request.getParameter("show");
	String sUser = request.getParameter("usr");
	String sPwd = request.getParameter("pwd");
	String sFileOwner = request.getParameter("owner");
	String sReportDs = "reporter";
	String sMsg;
	String sURLParams = "";
	String sElements = "";
	int iFldsReq = 0;
	boolean bSessionActive = true;
	boolean bMultiValueParams = false;
%>

<HTML>
<HEAD>
<meta HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="content-type" CONTENT="text/html; charset=<%=STR_CHARSET%>">
<TITLE>Netcool/Reporter 2.2 - <%= sReport %></TITLE>
<SCRIPT LANGUAGE="JavaScript">

<jsp:include page="/infospc/jsp/jsp.conf" flush="false" />

function getSelected(opt, element) {
  var txtfield = "";

  element.value = "";

  if ( opt.length == 0 )
  {
    return
  }

  for (var intLoop=0; intLoop < opt.length; intLoop++)
  {
    if (opt[intLoop].selected)
    {
      if ( txtfield == "" )
      {
        txtfield = opt[intLoop].value;
      }
      else
      {
        txtfield = txtfield.concat( document.separator, opt[intLoop].value );
      }
    }
  }

  element.value = txtfield;
}

function checkDatatype(element, datatype) {
   if ( element.value.length == 0 || datatype != "NUMBER" )
   {
      return;
   }

   var oneDecimal = false;

   for ( var i = 0; i < element.value.length; i++ )
   {
      var oneChar = element.value.charAt(i);

      if ( i == 0 && oneChar == "-" )
      {
         continue;
      }

      if ( oneChar == "." && !oneDecimal )
      {
         continue;
      }

      if ( oneChar < "0" || oneChar > "9" )
      {
         alert( "<i18n:message key="DatatypeOfParameterIsNumericOnly"/>: " + element.name );
	 break;
      }
    }
}

function isEmptyString( element ) {
   var bEmpty = true;

   if ( element.value.length == 0 )
   {
      return false;
   }

   for ( var i = 0; i < element.value.length; i++ )
   {
      var oneChar = element.value.charAt(i);

      if ( oneChar != " " )
      {
         bEmpty = false;
	 break;
      }
   }

   return bEmpty;
}

function submitForm( arrayElement ) {
   var elementArray = arrayElement;
   var nullElement = false;
   //add by zhwm 2007-10-26 for  reset page 500 error	
   //if(typeof(document.form.separator)   !=   "undefined") {  
   if(document.form.separator) {
	document.form.separator.value = document.separator;
   }
   //add end
   for ( var i=0; i < elementArray.length; i++ )
   {
      if ( elementArray[i].value == "" || isEmptyString( elementArray[i] ) )
      {
        alert( "<i18n:message key="PleaseAddValueForParameter"/>: " + elementArray[i].name );
				elementArray[i].value = "";
				nullElement = true;
				break;
      }else{
         elementArray[i].value = encodeURI(elementArray[i].value);
      }
   }

   if ( nullElement == false )
   {
      document.form.rep.value = encodeURI(document.form.rep.value);
      document.form.submit();
   }
}

</SCRIPT>

<% if ( sReport == null )
{ %>
	<% sMsg = bundle.getString("ReportToRun") + ":  rep = " + sReport; %>
	<% String sURL = "/infospc/jsp/netcool/tools/error.jsp?code=3&msg=" + sMsg; %>
	<jsp:forward page="<%=sURL%>" />
<% } %>

<% if ( sUser != null )
{ %>
	<server:sessionInfo resultObj="currentSessionInfo" />
	<% VJSession currentSession = (VJSession)pageContext.getAttribute("currentSessionInfo");
	if ( currentSession != null )
	{
		currentSession.setState( currentSession.SESSION_INVALID );
	}
} %>

<server:sessionInfo resultObj="sessionInfo" />
<% VJSession loginSession = (VJSession)pageContext.getAttribute("sessionInfo"); %>

<% if ( loginSession == null )
{
	bSessionActive = false;
} else if (loginSession.getState() != loginSession.SESSION_ACTIVE) {
	bSessionActive = false;
} %>

<% if ( !bSessionActive ) { %>
	<% if ( sUser != null && sPwd != null )
	{ %>
		<server:login user="<%= sUser %>" password="<%= sPwd %>" />
		<server:sessionInfo resultObj="sessionInfo" />

		<% String loginResult = (String) session.getAttribute("LOGIN_RESULT"); %>

		<% if ( !loginResult.equals("0") )
		{ %>
			<% String sURL = "/infospc/jsp/netcool/tools/error.jsp?code=5"; %>
			<jsp:forward page="<%=sURL%>" />
		<% } %>
	<% } else { %>
		<% sMsg = bundle.getString("ProvideUsernameAndPasswordToEstablishSession"); %>
		<% String sURL = "/infospc/jsp/netcool/tools/error.jsp?code=6&msg=" + sMsg; %>
		<jsp:forward page="<%=sURL%>" />
	<% } %>
<% } %>

</HEAD>

	<BODY TEXT="FFFFFF" LINK=#006666 VLINK="#3366cc" ALINK="FFFFFF" BGCOLOR="000031">
	<BASEFONT FACE="verdana, arial, helvetica, sans-serif" COLOR="#FFFFFF">

	<server:sessionInfo resultObj="sessionObj" />

	<%
	VJSession client = (VJSession)pageContext.getAttribute("sessionObj");
	if ( client == null ) { %>
		<jsp:forward page="/infospc/jsp/netcool/tools/error.jsp?code=1" />
	<% } %>

	<% if ( sFileOwner == null )
	{
		sFileOwner = client.getUserName();
	} %>

	<vrtlReport:getReport
		fileName="<%= sReport %>"
		fileOwner="<%= sFileOwner %>"
		result="reportObj" >
	</vrtlReport:getReport>

	<% Report repObj = (Report)pageContext.getAttribute("reportObj"); %>
	<% if ( repObj != null )
	{
		sReportDs = repObj.getDs();
	} else {
		String sURL = "/infospc/jsp/netcool/tools/error.jsp?code=4&msg=" + sReport; %>
		<jsp:forward page="<%=sURL%>" />
	<% } %>

	<vrtlReport:getParameterList
		fileName="<%= sReport %>"
		result="paramListObj">
	</vrtlReport:getParameterList>

	<% VJList paramList = (VJList)pageContext.getAttribute("paramListObj");
	if ( paramList == null )
	{%>
		<jsp:forward page="/infospc/jsp/netcool/tools/runnoparamrep.jsp" />
	<% } %>

	<% for ( int i=0;  i < paramList.size(); i++ )
	{
		boolean bFound;

		bFound = false;
		Parameter param = (Parameter)paramList.get(i);

		if ( param.isMultiValue() )
		{
			bMultiValueParams = true;
		}

		Enumeration params = request.getParameterNames();
		while ( params.hasMoreElements() )
		{
			String pName = (String)params.nextElement();

			if ( !pName.equals("rep") && pName.equals( param.getName() ) )
			{
				bFound = true;
			}
		}

		if ( bFound == false ) {
			if ( sElements.equals( "" ) ) {
				sElements = sElements + "this.form." + param.getName();
			} else {
				sElements = sElements + "," + "this.form." + param.getName();
			}
		}
	} %>

	<FORM NAME="form" METHOD="GET" ACTION="/infospc/jsp/netcool/tools/runparamrep.jsp">

	<INPUT TYPE="hidden" NAME="rep" VALUE="<%= sReport %>">
	<INPUT TYPE="hidden" NAME="own" VALUE="<%= sFileOwner %>">
	<INPUT TYPE="hidden" NAME="source" VALUE="runReport">

	<TABLE ALIGN="CENTER" WIDTH="100%" BORDER="0">
		<TBODY>
			<TR>
				<TD VALIGN="TOP" ALIGN="LEFT">
		<img alt="<i18n:message key="Alt_reporter_logo"/>" SRC="/infospc/images/netcool/reporter_logo.gif" BORDER="0">
				</TD>
			</TR>

			<TR>
				<TD><BR></TD>
			</TR>

			<TR ALIGN="LEFT">
				<TD COLSPAN="2">
		<TABLE ALIGN="LEFT" BORDER="0">
			<TBODY>
				<TR>
					<TD ALIGN="LEFT">
			<i18n:message key="Report"/>:
					</TD>
					<TD ALIGN="LEFT">
			<%=sReport%>
					</TD>
				</TR>

	<vrtlReport:getReportDetail
		fileName="<%= sReport %>"
		detail="desc"
		result="rdesc"/>

	<% Object descObj = pageContext.getAttribute("rdesc"); %>

	<% if ( descObj != null )
	{ %>
				<TR>
					<TD ALIGN="LEFT">
			<i18n:message key="Description"/>:
					</TD>
					<TD ALIGN="LEFT">
			<%= descObj %>
					</TD>
				</TR>
	<% } else if ( !(repObj.getDescription()).equals( "" ) )
	{ %>
				<TR>
					<TD ALIGN="LEFT">
			<i18n:message key="Description"/>:
					</TD>
					<TD ALIGN="LEFT">
			<%= repObj.getDescription() %>
					</TD>
				</TR>
	<% } %>

			</TBODY>
		</TABLE>
				</TD>
			</TR>

			<TR>
				<TD><BR></TD>
			</TR>

	<% if ( sShowParams == null )
	{ %>
			<TR>
				<TD ALIGN="CENTER">
		<H3><B><i18n:message key="Description"/>.</B></H3>
				</TD>
			</TR>
	<% } %>

			<TR>
				<TD><BR></TD>
			</TR>

			<TR ALIGN="CENTER">
				<TD>
		<TABLE CELLSPACING="0">
			<TBODY>

	<% for ( int i=0;  i < paramList.size(); i++ )
	{
		boolean bFound = false;
		Parameter param = (Parameter)paramList.get(i);

		Enumeration params = request.getParameterNames();
		while ( params.hasMoreElements() )
		{
			String pName = (String)params.nextElement(); %>

			<% if ( !pName.equals("rep") && pName.equals( param.getName() ) )
			{ %>
				<TR ALIGN="LEFT">
					<TD VALIGN="TOP">
			<TABLE>
							<TBODY>
					<TR>
						<TD>
				<B><%=param.getDescription()%>:</B>
						</TD>
					</TR>

					<TR VALIGN="TOP">
						<TD>
				<FONT SIZE="-3"><i18n:message key="ReportParameter"/> <%=param.getName()%>.</FONT>
						</TD>
					</TR>
				</TBODY>
			</TABLE>
					</TD>

					<TD>
			<INPUT TYPE="TEXT" NAME="<%= pName %>" VALUE="<%= request.getParameter(pName) %>" SIZE="25" READONLY STYLE="BORDER-WIDTH: 1px; BACKGROUND-COLOR: #C3C3C3">
					</TD>
				</TR>

				<%
				bFound = true;
				sURLParams += "&" + pName + "=" + request.getParameter(pName);

				if ( sElements.equals( "" ) )
				{
		sElements = sElements + "this.form." + param.getName();
				} else {
		sElements = sElements + "," + "this.form." + param.getName();
				}
			}
		} %>

		<%
		boolean bHasPreList = false;
		boolean bHasSqlList = false;

		if ( !bFound )
		{
			iFldsReq += 1;
			param = (Parameter)paramList.get(i);

			if ( !(param.getValueList()).equals( " ," ) && !(param.getValueList()).equals( "" ) )
			{
				bHasPreList = true;
			}

			if ( !param.isDbRestrict() )
			{
				if ( !(param.getSqlStmt()).equals( "null" ) && !(param.getSqlStmt()).equals( "" ) )
				{
					bHasSqlList = true;
				}
			} %>

				<TR ALIGN="LEFT">
					<TD VALIGN="TOP">
			<TABLE>
				<TBODY>
					<TR>
						<TD>
				<B><%= param.getDescription() %>:</B>
						</TD>
					</TR>

					<TR VALIGN="TOP">
						<TD>
				<FONT SIZE="-3"><i18n:message key="ReportParameter"/> <%= param.getName() %>.

			<% if ( param.isMultiValue() && param.isManualEntry() )
			{ %>
					<BR><BR><i18n:message key="SeperateMultipleEntriesWith"/> <INPUT TYPE="TEXT" NAME="separator" VALUE="" SIZE="1" READONLY STYLE="BORDER-WIDTH: 0px; BACKGROUND-COLOR: #000031; COLOR: #FFFFFF; FONT-WEIGHT:BOLD; WIDTH:20px">
<script type="text/javascript"><!--
function initiliseSeperator() {
	if ( document.separator.length == 0 )
	{
		alert( "<i18n:message key="ParameterSeparatorMustHaveValue"/>" );
		document.separator = "";
	}

	if ( document.separator == "\\" || document.separator == "?" || document.separator == "&" )
	{
		alert( "<i18n:message key="ParameterSeparatorLawlessValue"/>" );
		document.separator = "";
	}
}

initiliseSeperator();
document.form.separator.value = document.separator;
//--></script>
			<% } else if ( param.isMultiValue() )
			{ %>
					<INPUT TYPE="HIDDEN" NAME="separator" VALUE="">

<script type="text/javascript"><!--
function initiliseSeperator() {
	if ( document.separator.length == 0 )
	{
		alert( "<i18n:message key="ParameterErrorNoValue"/>\n"
				+ "<i18n:message key="EditConfTocorrectProblem"/>");
		document.separator = "";
	}

	if ( document.separator == "\\" || document.separator == "?" || document.separator == "&" )
	{
		alert( "<i18n:message key="ParameterErrorInvalidValue"/>\n"
				+ "<i18n:message key="EditConfTocorrectProblem"/>\n"
				+ "<i18n:message key="ParameterNoteInvalidValue"/>");
		document.separator = "";
	}
}

initiliseSeperator();
document.form.separator.value = document.separator;
//--></script>
			<% } %>

			</FONT>
		      </TD>
		    </TR>
		  </TBODY>
		</TABLE>
	      </TD>

	      <TD>
		<TABLE CELLSPACING="0" CELLPADDING="0" BORDER="0" WIDTH="100%">
		  <TBODY>
		    <TR>
		      <TD>

    <% if ( param.isManualEntry() )
    { %>
			<INPUT TYPE="TEXT" NAME="<%= param.getName() %>" SIZE="25"  onKeyup="checkDatatype( this, '<%=param.getDataType() %>' );" >
    <% } else { %>
			<INPUT TYPE="TEXT" NAME="<%= param.getName() %>" SIZE="25" READONLY STYLE="BORDER-WIDTH: 1px; BACKGROUND-COLOR: #C3C3C3" onKeyup="checkDatatype( this, '<%=param.getDataType() %>' );" >
    <% } %>

		      </TD>
		    </TR>

		    <TR>

    <%
    String sPassedThru;
    String sEvent;
    String sAction;

    String sUserAgent = request.getHeader("user-agent");

    if ( sUserAgent.lastIndexOf( "Mozilla/4.7" ) != -1 )
    {
      sAction = "onchange";
    } else {
      sAction = "onclick";
    }

    if ( param.isMultiValue() )
    {
      sEvent = "onchange=\"getSelected(this, document.form." + param.getName() + ", document.separator);\"" + " " + sAction + "=\"getSelected( this, document.form." + param.getName() + ", document.separator);\"";
    } else {
      sEvent = sAction + "=\"getSelected(this, document.form." + param.getName() + ", document.separator);\"";
    }

    sPassedThru = "SIZE=\"5\" STYLE=\"WIDTH: 100%\" " + sEvent; %>

		      <TD>
			<TABLE WIDTH=100% CELLPADDING="0" CELLSPACING="0" BORDER="0">
			  <TBODY>
			    <TR>
    <% if ( bHasPreList )
    {
      if ( bHasSqlList )
      { %>
			      <TD WIDTH="50%">
      <% } else { %>
			      <TD>
      <% } %>

			        <vrtlReport:dropdown
								name=""
								multiple="<%=String.valueOf(param.isMultiValue())%>"
								data="<%=param.getPreselectedValues()%>"
								passedThru="<%= sPassedThru %>" />
			      </TD>
      <% } %>

      <% if ( bHasSqlList )
      { %>
        <% if ( bHasPreList )
        { %>
			      <TD WIDTH="50%">
        <% } else { %>
			      <TD>
        <% } %>

				<vrtlReport:dropdown
				  name=""
				  multiple="<%=String.valueOf(param.isMultiValue())%>"
				  passedThru="<%= sPassedThru %>" >

				  <vrtlReport:sqlData
				    sql="<%= param.getSqlStmt() %>"
				    ds="<%= sReportDs %>"/>

				</vrtlReport:dropdown>
			      </TD>
      <% } %>
			    </TR>

			    <TR VALIGN="TOP">

      <% if ( bHasPreList && bHasSqlList )
      { %>
			      <TD ALIGN="CENTER" WIDTH="50%">
				<FONT SIZE="-3"><i18n:message key="Predefined"/></FONT>
			      </TD>
			      <TD ALIGN="CENTER" WIDTH="50%">
				<FONT SIZE="-3"><i18n:message key="Database"/></FONT>
      <% } else if ( bHasPreList )
      { %>
			      <TD ALIGN="CENTER">
				<FONT SIZE="-3"><i18n:message key="Predefined"/></FONT>
      <% } else if ( bHasSqlList )
      { %>
			      <TD ALIGN="CENTER" WIDTH="50%">
				<FONT SIZE="-3"><i18n:message key="Database"/></FONT>
      <% } %>
			      </TD>
			    </TR>

			  </TBODY>
			</TABLE>
		      </TD>
		    </TR>
		  </TBODY>
		</TABLE>
	      </TD>
	    </TR>
  <% } %>

	    <TR>
	      <TD>
		<BR>
	      </TD>
	    </TR>

<% } %>

	  </TBODY>
	</TABLE>
      </TD>
    </TR>

<% if ( iFldsReq == 0 && sShowParams == null ) { %>
  <% 
  String strowner="";
  if(sFileOwner!=null && !sFileOwner.equalsIgnoreCase("") ){
  	strowner=sFileOwner;
  }else{
  	strowner=client.getUserName();
  }

  //Fixed by Sheryl.zhao for bug 13401
//  String sURL = "/infospc/jsp/netcool/tools/runparamrep.jsp?" + "rep=" + sReport + "&own=" +strowner + sURLParams; 
  String sURL = "/infospc/jsp/netcool/tools/runparamrep.jsp?" + "rep=" + sReportPara + "&own=" +strowner + sURLParams; 
  %>
  <jsp:forward page="<%=sURL%>" />
<% } else { %>

    <TR>
      <TD COLSPAN="2">
	<TABLE WIDTH="100%" HEIGHT="100%" BORDER="0">
	  <TBODY>
	    <TR ALIGN="CENTER">
  <% if ( iFldsReq > 0 )
  { %>
	      <TD ALIGN="RIGHT" WIDTH="50%">
  <% } else { %>
	      <TD ALIGN="CENTER">
  <% } %>
		<INPUT TYPE="BUTTON" VALUE="<i18n:message key="Button_Submit"/>" onclick="submitForm( new Array(<%=sElements%>) );" >
	      </TD>

  <% if ( iFldsReq > 0 )
  { %>
	      <TD ALIGN="LEFT" WIDTH="50%">
		<INPUT TYPE="RESET" VALUE="<i18n:message key="Button_Reset"/>" >
	      </TD>
  <% } %>
	    </TR>
	  </TBODY>
	</TABLE>
      </TD>
    </TR>

<% } %>

  </TBODY>
</TABLE>

</FORM>
