<%--
  -- File     : viewsnapshot.jsp
  -- Publisher: Micromuse Ltd.
  -- Project  : Netcool/Reporter 2.0
  -- Created  : October 21, 2003
  -- Creator  : Stuart V Cook - Senior Software Consultant
  -- Copyright: Micromuse Inc (c) 2003-2005

  -- Change Log
  -- ----------
	-- December 14, 2004:
  --	* Added user name (usr) and user password (pwd) parameters to the tool
	--		URL to enable log in when no session currently exists.
  --	* Invalidated any existing user session if the user name (usr) was passed
	--		over the URL, as this implies the user wishes to relogin.
  --	* Added a file owner (owner) parameter to the URL, to allow the user to
	--		specify a report snapshot which belongs to another user.
  --	* Enabled no caching of this page to ensure that web server does not
	--		maintain any state persistent data.
	--
--%>

<%@ include file="../../../charset.inc"%>

<%@ taglib uri="/infospc/tld/vctl/vctl.tld" prefix="server" %>
<%@ page import="com.viador.infra.shared.vjobj.*" %>
<%@ page import="com.viador.infra.webclient.client.*" %>
<%@ page import="java.util.*" %>
<%@ taglib uri="/infospc/tld/i18n/i18n.tld" prefix="i18n" %>
<%@ include file="./util.jsp"%>
<i18n:bundle baseName="resources/portaljsp"
	     localeRef="userLocale"
             id="bundle"/>
<%
	response.setContentType("text/html; charset=" + STR_CHARSET);
	response.setHeader("Pragma", "No-cache");
	response.setDateHeader("Expires", 0);
	response.setHeader("Cache-Control", "no-cache");

	String sUser = (String) request.getParameter("usr");
	String sPwd = (String) request.getParameter("pwd");
	String sFileOwner = (String) request.getParameter("owner");
	String sSnapshot = (String) request.getParameter("snap");
	String sFolder = (String) request.getParameter("folder");
       String charset = getRequestCharset(request);
	if(sSnapshot != null) {
                if(charset!=null){
		       sSnapshot =  new String(sSnapshot.getBytes("ISO-8859-1"),charset);
                }else{
                    sSnapshot =  new String(sSnapshot.getBytes("ISO-8859-1"));
                }
	}
	if(sFolder != null) {
                if(charset!=null){
		       sFolder =  new String(sFolder.getBytes("ISO-8859-1"),charset);
                }else{
                     sFolder =  new String(sFolder.getBytes("ISO-8859-1"));
                }
		  if(sFolder.equals(bundle.getString("Inbox"))) {
			sFolder = "Inbox";
		  }
	}
	String sMsg;
	boolean bSessionActive = true;
%>

<% if ( sUser != null )
{ %>
	<server:sessionInfo resultObj="currentSessionInfo" />
	<% VJSession currentSession = (VJSession)pageContext.getAttribute("currentSessionInfo");
	if ( currentSession != null )
	{
		currentSession.setState( currentSession.SESSION_INVALID );
	}
} %>

<server:sessionInfo resultObj="sessionInfo" />
<% VJSession loginSession = (VJSession)pageContext.getAttribute("sessionInfo"); %>

<% if ( loginSession == null )
{
	bSessionActive = false;
} else if (loginSession.getState() != loginSession.SESSION_ACTIVE) {
	bSessionActive = false;
} %>

<% if ( !bSessionActive ) { %>
	<% if ( sUser != null && sPwd != null )
	{ %>
		<server:login user="<%= sUser %>" password="<%= sPwd %>" />
		<server:sessionInfo resultObj="sessionInfo" />

		<% String loginResult = (String) session.getAttribute("LOGIN_RESULT"); %>

		<% if ( !loginResult.equals("0") )
		{ %>
			<% String sURL = "/infospc/jsp/netcool/tools/error.jsp?code=5"; %>
			<jsp:forward page="<%=sURL%>" />
		<% } %>
	<% } else { %>
		<% sMsg = bundle.getString("ProvideUsernameAndPasswordToEstablishSession"); %>
		<% String sURL = "/infospc/jsp/netcool/tools/error.jsp?code=6&msg=" + sMsg; %>
		<jsp:forward page="<%=sURL%>" />
	<% } %>
<% } %>

<server:sessionInfo resultObj="sessionObj" />
<% VJSession client = (VJSession)pageContext.getAttribute("sessionObj"); %>

<%
	if ( sSnapshot != null ) {
		if ( sFolder == null) {
			sFolder = "Inbox";
		}
		if ( client == null ) {
%>
		<jsp:forward page="/infospc/jsp/netcool/tools/error.jsp?code=1" />
<%
		}
		if ( sFileOwner == null ) {
			sFileOwner = client.getUserName();
		}
%>

	<server:getFile folderName="<%=sSnapshot%>"
		parentName="<%=sFolder%>"
		ownerName="<%=sFileOwner%>"
		sresultObj="fileObj" />

	<% VJFile file = (VJFile)pageContext.getAttribute("fileObj");
	if ( file != null )
	{
		file.setSessionId(client.getId());
		String sFileUrl = file.getUrl(); %>
		<META HTTP-EQUIV="Refresh" CONTENT="0;URL=<%=sFileUrl%>">
	<% } else { %>
		<% sMsg = sSnapshot; %>
		<% String sURL = "/infospc/jsp/netcool/tools/error.jsp?code=4&msg=" + sMsg; %>
		<jsp:forward page="<%=sURL%>" />
	<% } %>
<% } else { %>
	<% sMsg = "folder (optional), and<LI>snap (required)."; %>
	<% String sURL = "/infospc/jsp/netcool/tools/error.jsp?code=3&msg=" + sMsg; %>
	<jsp:forward page="<%=sURL%>" />
<% } %>
